// LeftDlg.cpp : implementation file
//

#include "stdafx.h"
#include "atc.h"
#include "LeftDlg.h"
//#include "MainFrm.h"
#include "atcDoc.h"
//#include "atcView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLeftDlg

IMPLEMENT_DYNCREATE(CLeftDlg, CFormView)

CLeftDlg::CLeftDlg()
	: CFormView(CLeftDlg::IDD)
{
	//{{AFX_DATA_INIT(CLeftDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CLeftDlg::~CLeftDlg()
{
}

void CLeftDlg::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLeftDlg)
	DDX_Control(pDX, IDC_EDIT_ZOOM, m_ebZoom);
	DDX_Control(pDX, IDC_EDIT_SPEED, m_ebSpeed);
	DDX_Control(pDX, IDC_EDIT_ALTITUDE, m_ebAltitude);
	DDX_Control(pDX, IDC_LIST_COMMANDS, m_lbCommands);
	DDX_Control(pDX, IDC_EDIT_HEADING, m_ebHeading);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLeftDlg, CFormView)
	//{{AFX_MSG_MAP(CLeftDlg)
	ON_BN_CLICKED(IDC_BTN_SCROLL_VP_UP, OnButtonScrollUp)
	ON_BN_CLICKED(IDC_BTN_SCROLL_VP_DOWN, OnButtonScrollDown)
	ON_BN_CLICKED(IDC_BTN_ZOOM_PLUS, OnBtnZoomPlus)
	ON_BN_CLICKED(IDC_BTN_ZOOM_MINUS, OnBtnZoomMinus)
	ON_BN_CLICKED(IDC_BUTTON_HEAD_INC, OnButtonHeadIncrease)
	ON_BN_CLICKED(IDC_BUTTON_HEAD_DEC, OnButtonHeadDecrease)
	ON_BN_CLICKED(IDC_BUTTON_HEAD, OnButtonHeadCommand)
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_BUTTON_ALTITUDE_INC, OnButtonAltitudeIncrease)
	ON_BN_CLICKED(IDC_BUTTON_ALTITUDE_DEC, OnButtonAltitudeDecrease)
	ON_BN_CLICKED(IDC_BUTTON_ALTITUDE, OnButtonAltitudeCommand)
	ON_BN_CLICKED(IDC_BUTTON_SPEED_INC, OnButtonSpeedInc)
	ON_BN_CLICKED(IDC_BUTTON_SPEED_DEC, OnButtonSpeedDec)
	ON_BN_CLICKED(IDC_BUTTON_SPEED, OnButtonSpeedCommand)
	ON_BN_CLICKED(IDC_BUTTON_SEL_PREV_AIRCRAFT, OnButtonSelectPreviousAircraft)
	ON_BN_CLICKED(IDC_BUTTON_SEL_NEXT_AIRCRAFT, OnButtonSelectNextAircraft)
	ON_BN_CLICKED(IDC_BTN_SCROLL_VP_LEFT, OnBtnScrollViewPortLeft)
	ON_BN_CLICKED(IDC_BTN_SCROLL_VP_RIGHT, OnBtnScrollViewPortRight)
	ON_BN_CLICKED(IDC_BTN_FINAL_APPROACH, OnButtonFinalApproachCommand)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLeftDlg diagnostics

#ifdef _DEBUG
void CLeftDlg::AssertValid() const
{
	CFormView::AssertValid();
}

void CLeftDlg::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CLeftDlg message handlers

void CLeftDlg::OnButtonScrollUp() 
{
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
pDoc->m_nViewPortOrgY-=25;
POINT pt;
pt.x =pDoc->m_nViewPortOrgX;
pt.y =pDoc->m_nViewPortOrgY;
pDoc->m_runway.CalcPoints (pt,pDoc->m_nScaleFactor);

pDoc->UpdateAllViews(this); 	
	
}

void CLeftDlg::OnButtonScrollDown() 
{
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
pDoc->m_nViewPortOrgY+=5;
POINT pt;
pt.x =pDoc->m_nViewPortOrgX;
pt.y =pDoc->m_nViewPortOrgY;
pDoc->m_runway.CalcPoints (pt,pDoc->m_nScaleFactor);
	
pDoc->UpdateAllViews(this); 	

}

void CLeftDlg::OnBtnZoomPlus() 
{
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
pDoc->m_nScaleFactor+=10;
CString strVal;
strVal.Format ("%i",pDoc->m_nScaleFactor);
m_ebZoom.SetWindowText (strVal);

POINT pt;
pt.x =pDoc->m_nViewPortOrgX;
pt.y =pDoc->m_nViewPortOrgY;
pDoc->m_runway.CalcPoints (pt,pDoc->m_nScaleFactor);
pDoc->UpdateAllViews(this); 	
 
}


void CLeftDlg::OnBtnZoomMinus() 
{
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
pDoc->m_nScaleFactor-=10;
CString strVal;
strVal.Format ("%i",pDoc->m_nScaleFactor);
m_ebZoom.SetWindowText (strVal);

POINT pt;
pt.x =pDoc->m_nViewPortOrgX;
pt.y =pDoc->m_nViewPortOrgY;
pDoc->m_runway.CalcPoints (pt,pDoc->m_nScaleFactor);

pDoc->UpdateAllViews(this); 	
}

void CLeftDlg::OnButtonHeadIncrease() 
{

int i;
CString strVal;
m_ebHeading.GetWindowText(strVal);
i=atoi(strVal);
i+=5;
strVal.Format ("%i",i);
m_ebHeading.SetWindowText (strVal);
 	
}

void CLeftDlg::OnButtonHeadDecrease() 
{
int i;
CString strVal;
m_ebHeading.GetWindowText(strVal);
i=atoi(strVal);
i-=5;
strVal.Format ("%i",i);
m_ebHeading.SetWindowText (strVal);
}

void CLeftDlg::OnButtonHeadCommand() 
{
char *stop;
double 	nStartCourse;
int nCount;
int nCount1;
int nCount2;
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
CString strVal;
CString strCommand;
m_ebHeading.GetWindowText(strVal);
pDoc->m_pCurrentAircraft->m_nRequiredTrueCourse=strtod(strVal,&stop);
nCount1=0;
nCount2=0;
	if(pDoc->m_pCurrentAircraft->m_TrueCourse!=pDoc->m_pCurrentAircraft->m_nRequiredTrueCourse )

	{	
		nStartCourse=pDoc->m_pCurrentAircraft->m_TrueCourse;
		while(pDoc->m_pCurrentAircraft->m_nRequiredTrueCourse!=nStartCourse)
		{
			nStartCourse++;
			if(nStartCourse==360)nStartCourse=0;
			nCount1++;

		}
		nStartCourse=pDoc->m_pCurrentAircraft->m_TrueCourse;
		while(pDoc->m_pCurrentAircraft->m_nRequiredTrueCourse!=nStartCourse)
		{
			nStartCourse--;
			if(nStartCourse==-1)nStartCourse=359;
			nCount2++;

		}

		nCount1 < nCount2 ? pDoc->m_pCurrentAircraft->m_nLeftRight=2:pDoc->m_pCurrentAircraft->m_nLeftRight=1;
	}


nCount=m_lbCommands.GetCount();
if(nCount>10)m_lbCommands.ResetContent (); 
strCommand="-Heading "+strVal;
m_lbCommands.AddString (strCommand);
pDoc->strCurrentMessage=pDoc->m_pCurrentAircraft->strATCName +strCommand;

	
}

int CLeftDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CFormView::OnCreate(lpCreateStruct) == -1)
		return -1;
/*CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
CString strVal;
strVal.Format ("%.1f",pDoc->m_nScaleFactor);
m_ebZoom.SetWindowText (strVal);*/
	

	
	return 0;
}

LRESULT CLeftDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(message ==WM_GAME_STARTED)
	{
		m_ebHeading.SetWindowText ("0");
	}
	return CFormView::WindowProc(message, wParam, lParam);
}

BOOL CLeftDlg::PreTranslateMessage(MSG* pMsg) 
{
	// TODO: Add your specialized code here and/or call the base class
	if(pMsg->message ==WM_GAME_STARTED)
	{
		m_ebHeading.SetWindowText ("0");
	}
	return CFormView::PreTranslateMessage(pMsg);
}

void CLeftDlg::OnButtonAltitudeIncrease() 
{
int i;
CString strVal;
m_ebAltitude.GetWindowText(strVal);
i=atoi(strVal);
i+=100;
strVal.Format ("%i",i);
m_ebAltitude.SetWindowText (strVal);		
	
}

void CLeftDlg::OnButtonAltitudeDecrease() 
{
	// TODO: Add your control notification handler code here
int i;
CString strVal;
m_ebAltitude.GetWindowText(strVal);
i=atoi(strVal);
i-=100;
strVal.Format ("%i",i);
m_ebAltitude.SetWindowText (strVal);	
}

void CLeftDlg::OnButtonAltitudeCommand() 
{
	// TODO: Add your control notification handler code here
char *stop;	
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
CString strVal;
CString strCommand;

int nCount;
m_ebAltitude.GetWindowText(strVal);
pDoc->m_pCurrentAircraft->m_nRequiredAltitude =strtod(strVal,&stop);
//pDoc->m_pCurrentAircraft->m_bChangeParameters=TRUE;
	if(pDoc->m_pCurrentAircraft->m_nRequiredAltitude>pDoc->m_pCurrentAircraft->m_nAltitude)
		{
			pDoc->m_pCurrentAircraft->m_nUpDown=1;//Up
		}
		else
		{
			pDoc->m_pCurrentAircraft->m_nUpDown=0;
			
		}
strCommand="-Maintain Alt "+strVal;

nCount=m_lbCommands.GetCount();
if(nCount>10)m_lbCommands.ResetContent (); 
m_lbCommands.AddString (strCommand);
pDoc->strCurrentMessage=pDoc->m_pCurrentAircraft->strATCName +strCommand;

}

void CLeftDlg::OnButtonSpeedInc() 
{
	// TODO: Add your control notification handler code here
int i;
CString strVal;
m_ebSpeed.GetWindowText(strVal);
i=atoi(strVal);
i+=10;
strVal.Format ("%i",i);
m_ebSpeed.SetWindowText (strVal);	
}

void CLeftDlg::OnButtonSpeedDec() 
{
	// TODO: Add your control notification handler code here
int i;
CString strVal;
m_ebSpeed.GetWindowText(strVal);
i=atoi(strVal);
i-=10;
strVal.Format ("%i",i);
m_ebSpeed.SetWindowText (strVal);	
}

void CLeftDlg::OnButtonSpeedCommand() 
{
char *stop;	
double speed;
int nCount;
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
CString strVal;
CString strCommand;
m_ebSpeed.GetWindowText(strVal);

speed=strtod(strVal,&stop);
	if(speed>(double)pDoc->m_pCurrentAircraft->m_nMaxSpeed)
	{
		speed=(double)pDoc->m_pCurrentAircraft->m_nMaxSpeed;
		m_lbCommands.AddString("Cannot Maintain High Speed");
	}
	if(speed<(double)pDoc->m_pCurrentAircraft->m_nMinSpeed)
	{
		speed=(double)pDoc->m_pCurrentAircraft->m_nMinSpeed;
		m_lbCommands.AddString("Cannot Maintain Low Speed");
	}
//m_pCurrentAircraft->m_nMinSpeed=100;
pDoc->m_pCurrentAircraft->m_nRequiredSpeed  =speed;
strCommand="-Maintain Speed "+strVal;
nCount=m_lbCommands.GetCount();
if(nCount>10)m_lbCommands.ResetContent (); 
m_lbCommands.AddString (strCommand);
pDoc->strCurrentMessage=pDoc->m_pCurrentAircraft->strATCName +strCommand;

	
}

void CLeftDlg::OnButtonSelectPreviousAircraft() 
{
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();	
if(pDoc->m_nSelectedAircraftIndex>0)
	{
		pDoc->m_nSelectedAircraftIndex--;
		pDoc->m_pCurrentAircraft=(CAircraft *)pDoc->m_ArrayAircrafts.GetAt (pDoc->m_nSelectedAircraftIndex);
pDoc->UpdateAllViews(this); 	

	}		
}

void CLeftDlg::OnButtonSelectNextAircraft() 
{
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();	
	if(pDoc->m_nSelectedAircraftIndex<pDoc->m_ArrayAircrafts.GetUpperBound())
	{	pDoc->m_nSelectedAircraftIndex++;
		pDoc->m_pCurrentAircraft=(CAircraft *)pDoc->m_ArrayAircrafts.GetAt (pDoc->m_nSelectedAircraftIndex);
		pDoc->UpdateAllViews(this); 	

	}		
}

void CLeftDlg::OnBtnScrollViewPortLeft() 
{
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
pDoc->m_nViewPortOrgX-=5;
POINT pt;
pt.x =pDoc->m_nViewPortOrgX;
pt.y =pDoc->m_nViewPortOrgY;
pDoc->m_runway.CalcPoints (pt,pDoc->m_nScaleFactor);
	
pDoc->UpdateAllViews(this); 	
}

void CLeftDlg::OnBtnScrollViewPortRight() 
{
	// TODO: Add your control notification handler code here
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
pDoc->m_nViewPortOrgX+=5;
POINT pt;
pt.x =pDoc->m_nViewPortOrgX;
pt.y =pDoc->m_nViewPortOrgY;
pDoc->m_runway.CalcPoints (pt,pDoc->m_nScaleFactor);
	
pDoc->UpdateAllViews(this); 	
}

void CLeftDlg::OnButtonFinalApproachCommand() 
{
CAtcDoc *pDoc=(CAtcDoc *)GetDocument();
BOOL b;
POINT pt;
pt.x =pDoc->m_nViewPortOrgX ;
pt.y =pDoc->m_nViewPortOrgY ;

b=pDoc->m_pCurrentAircraft->CheckForApproachEntryPoint(pDoc->m_nScaleFactor ,pt,pDoc->m_nActiveRunway,pDoc->m_runway.m_points[2].x , 
													 pDoc->m_runway.m_points[2].y ,2000);
if(b==TRUE)
		{
	
				pDoc->strCurrentMessage="Clear For Final Landing";	
				pDoc->m_pCurrentAircraft->m_nRequiredTrueCourse =pDoc->m_pCurrentAircraft->m_TrueCourse = pDoc->m_nActiveRunway;
				 
			}
}
