#if !defined(AFX_LEFTDLG_H__C540C28A_AA13_434D_9EF4_E761C24DD6F0__INCLUDED_)
#define AFX_LEFTDLG_H__C540C28A_AA13_434D_9EF4_E761C24DD6F0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// LeftDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CLeftDlg form view

#ifndef __AFXEXT_H__
#include <afxext.h>
#endif

class CLeftDlg : public CFormView
{
protected:
	CLeftDlg();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CLeftDlg)

// Form Data
public:
	//{{AFX_DATA(CLeftDlg)
	enum { IDD = IDD_DLG_LEFT_DLG };
	CEdit	m_ebZoom;
	CEdit	m_ebSpeed;
	CEdit	m_ebAltitude;
	CListBox	m_lbCommands;
	CEdit	m_ebHeading;
	//}}AFX_DATA

// Attributes
public:

// Operations
public:
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CLeftDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL

// Implementation
protected:
	virtual ~CLeftDlg();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	// Generated message map functions
	//{{AFX_MSG(CLeftDlg)
	afx_msg void OnButtonScrollUp();
	afx_msg void OnButtonScrollDown();
	afx_msg void OnBtnZoomPlus();
	afx_msg void OnBtnZoomMinus();
	afx_msg void OnButtonHeadIncrease();
	afx_msg void OnButtonHeadDecrease();
	afx_msg void OnButtonHeadCommand();
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnButtonAltitudeIncrease();
	afx_msg void OnButtonAltitudeDecrease();
	afx_msg void OnButtonAltitudeCommand();
	afx_msg void OnButtonSpeedInc();
	afx_msg void OnButtonSpeedDec();
	afx_msg void OnButtonSpeedCommand();
	afx_msg void OnButtonSelectPreviousAircraft();
	afx_msg void OnButtonSelectNextAircraft();
	afx_msg void OnBtnScrollViewPortLeft();
	afx_msg void OnBtnScrollViewPortRight();
	afx_msg void OnButtonFinalApproachCommand();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_LEFTDLG_H__C540C28A_AA13_434D_9EF4_E761C24DD6F0__INCLUDED_)
