// Options.cpp : implementation file
//

#include "stdafx.h"
#include "atc.h"
#include "Options.h"
#include "MainFrm.h"
#include "atcDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptions dialog


COptions::COptions(CWnd* pParent /*=NULL*/)
	: CDialog(COptions::IDD, pParent)
{
	//{{AFX_DATA_INIT(COptions)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void COptions::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptions)
	DDX_Control(pDX, IDC_EDIT_INTERVAL, m_ebInterval);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptions, CDialog)
	//{{AFX_MSG_MAP(COptions)
	ON_BN_CLICKED(IDC_BUTTON_INTERVAL_PLUS, OnButtonIntervalPlus)
	ON_BN_CLICKED(IDC_BUTTON_INTERVAL_MINUS, OnButtonIntervalMinus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptions message handlers

void COptions::OnOK() 
{
	// TODO: Add extra validation here
	CString strVal;
	CMainFrame *main = (CMainFrame *) AfxGetMainWnd();
	CAtcDoc *pDoc=(CAtcDoc *) main->GetActiveDocument();
	m_ebInterval.GetWindowText (strVal);
	pDoc->m_nAircraftGenerationInterval=atol(strVal)*60000;


	CButton *CheckSlowPlanesOpt=(CButton *)GetDlgItem(IDC_CHECK_SLOW_PLANES_OPT);
	if(CheckSlowPlanesOpt->GetCheck())pDoc->m_bGenerateSlowPlanes =TRUE; 
	CButton *pRadio1=(CButton *) GetDlgItem(IDC_RADIO_TUT_LEVEL);
	if(pRadio1->GetCheck ())pDoc->m_bTutorial =TRUE;

	CDialog::OnOK();
}

BOOL COptions::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CString strVal;
	CMainFrame *main = (CMainFrame *) AfxGetMainWnd();
	CAtcDoc *pDoc=(CAtcDoc *) main->GetActiveDocument();
	CButton *CheckSlowPlanesOpt=(CButton *)GetDlgItem(IDC_CHECK_SLOW_PLANES_OPT);
	m_nInterval=pDoc->m_nAircraftGenerationInterval/60000;
	strVal.Format ("%d",m_nInterval);
	m_ebInterval.SetWindowText (strVal);
	if(pDoc->m_bGenerateSlowPlanes ==TRUE)CheckSlowPlanesOpt->SetCheck (1);
	CButton *pRadio1=(CButton *) GetDlgItem(IDC_RADIO_TUT_LEVEL);
	pRadio1->SetCheck (1);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptions::OnButtonIntervalPlus() 
{
	// TODO: Add your control notification handler code here
		CString strVal;
		if(m_nInterval<30)
		{	
			m_nInterval++;
			strVal.Format ("%i",m_nInterval);
			m_ebInterval.SetWindowText (strVal);
		}
}

void COptions::OnButtonIntervalMinus() 
{
	CString strVal;
	if(m_nInterval>1)
	{	
		
		m_nInterval--;
		strVal.Format ("%i",m_nInterval);
		m_ebInterval.SetWindowText (strVal);
	}
}
