// Runway.cpp: implementation of the CRunway class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "atc.h"
#include "Runway.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#define TWOPI       (2 * 3.14159)

CRunway::CRunway()
{
	int i;
m_nHeading =30.0f;
m_nLength =1000;
m_nWidth=15;

m_nCoordX=320;
m_nCoordY=240;
	for(i=0;i<6;i++)
	{
	m_points[i].x =0;
	m_points[i].y =0;
	}

}

CRunway::~CRunway()
{

}

void CRunway::Draw(CDC *pDC)
{
pDC->MoveTo(m_points[0]);
pDC->LineTo(m_points[1]);
pDC->LineTo(m_points[5]);
pDC->LineTo(m_points[4]);
pDC->LineTo(m_points[0]);

//pDC->Rectangle (m_points[2].x-2,m_points[2].y-2,m_points[2].x+2,m_points[2].y+2);
pDC->MoveTo(m_points[2].x-5,m_points[2].y );
pDC->LineTo (m_points[2].x,m_points[2].y-5);
pDC->LineTo (m_points[2].x+5,m_points[2].y); 
pDC->LineTo (m_points[2].x-5,m_points[2].y); 

pDC->MoveTo(m_points[3].x-5,m_points[3].y );
pDC->LineTo (m_points[3].x,m_points[3].y-5);
pDC->LineTo (m_points[3].x+5,m_points[3].y); 
pDC->LineTo (m_points[3].x-5,m_points[3].y); 


 
}

void CRunway::CalcPoints(POINT pt,int nZoom)
{
int i;
//pt0+++pt1
//+xxxxxxx+
//+xxxxxxx+
//+xxxxxxx+
//+xxxxxxx+
//pt2xxxpt3
//+xxxxxxx+
//+xxxxxxx+
//+xxxxxxx+
//+xxxxxxx+
//pt4xxxpt5
	
//POINT pt0,pt1,pt2,pt3,pt4;

POINT ptOrg,ptDest;
//POINT pt;
POINT pts[6];
double dZoom=(double )nZoom;
//dZoom=dZoom*5;
double dRadiusLength;//=m_nLength/dZoom;
double dRadiusWidth;//=
double angle=-m_nHeading;
dRadiusLength=m_nLength/50;
dRadiusLength*=dZoom/50;
dRadiusWidth=m_nWidth/50;
dRadiusWidth*=dZoom/50;
m_nCoordX=pt.x ;
m_nCoordY=pt.y ;
ptOrg.x =m_nCoordX ;
ptOrg.y =m_nCoordY;

ptDest.y =(int)cos(TWOPI * angle/ 360)*(dRadiusLength) ;
ptDest.x =(int)sin(TWOPI * angle/ 360)*(dRadiusLength);
ptDest.y+=m_nCoordY;
ptDest.x+=m_nCoordX;
angle-=90;
m_points[4].y =cos(TWOPI * angle/ 360)*(dRadiusWidth) ;
m_points[4].x =sin(TWOPI * angle/ 360)*(dRadiusWidth);
m_points[4].x +=ptDest.x;
m_points[4].y +=ptDest.y;
//pDC->MoveTo(m_points[4]);
//pDC->LineTo(ptDest);


angle=-m_nHeading;
angle+=90;
m_points[5].y =cos(TWOPI * angle/ 360)*(dRadiusWidth) ;
m_points[5].x =sin(TWOPI * angle/ 360)*(dRadiusWidth);
m_points[5].x +=ptDest.x;
m_points[5].y +=ptDest.y;
//pDC->MoveTo(m_points[5]);
//pDC->LineTo(ptDest);

angle-=90;
m_points[2].y =cos(TWOPI * angle/ 360)*(dRadiusWidth) ;
m_points[2].x =sin(TWOPI * angle/ 360)*(dRadiusWidth);

m_points[2].x +=m_nCoordX;
m_points[2].y +=m_nCoordY;
//pDC->MoveTo(m_points[2]);
//pDC->LineTo(ptOrg);

angle=-m_nHeading;
angle+=90;
m_points[3].y =cos(TWOPI * angle/ 360)*(dRadiusWidth) ;
m_points[3].x =sin(TWOPI * angle/ 360)*(dRadiusWidth);
m_points[3].x +=m_nCoordX;
m_points[3].y +=m_nCoordY;

angle=-(m_nHeading-180);
ptOrg.x =m_nCoordX;
ptOrg.y =m_nCoordY;
ptDest.y =cos(TWOPI * angle/ 360)*(dRadiusLength) ;
ptDest.x =sin(TWOPI * angle/ 360)*(dRadiusLength);
ptDest.y+=m_nCoordY;
ptDest.x+=m_nCoordX;

angle-=90;
m_points[1].y =cos(TWOPI * angle/ 360)*(dRadiusWidth) ;
m_points[1].x =sin(TWOPI * angle/ 360)*(dRadiusWidth);
m_points[1].x +=ptDest.x;
m_points[1].y +=ptDest.y;

angle=-(m_nHeading+90);
m_points[0].y =cos(TWOPI * angle/ 360)*(dRadiusWidth) ;
m_points[0].x =sin(TWOPI * angle/ 360)*(dRadiusWidth);
m_points[0].x +=ptDest.x;
m_points[0].y +=ptDest.y;

/*pDC->MoveTo(m_points[0]);
pDC->LineTo(m_points[1]);
pDC->LineTo(m_points[5]);
pDC->LineTo(m_points[4]);
pDC->LineTo(m_points[0]);*/
///////////////////////////////////////////////////////////
//  dessin du waypoint d'entree
///////////////////////////////////////////////////////////
angle=-m_nHeading;
		m_points[2].y =cos(TWOPI * angle/ 360)*(dRadiusLength*4) ;
		m_points[2].x =sin(TWOPI * angle/ 360)*(dRadiusLength*4);
		m_points[2].y+=m_nCoordY;
		m_points[2].x+=m_nCoordX;
		
angle=angle+180;
		m_points[3].y =cos(TWOPI * angle/ 360)*(dRadiusLength*4) ;
		m_points[3].x =sin(TWOPI * angle/ 360)*(dRadiusLength*4);
		m_points[3].y+=m_nCoordY;
		m_points[3].x+=m_nCoordX;
}


