// atcView.h : interface of the CAtcView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_ATCVIEW_H__4846C8A4_267F_449D_87A4_60BB725EDD2F__INCLUDED_)
#define AFX_ATCVIEW_H__4846C8A4_267F_449D_87A4_60BB725EDD2F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CAtcView : public CView
{
protected: // create from serialization only
	CAtcView();
	DECLARE_DYNCREATE(CAtcView)

// Attributes
public:
	CAtcDoc* GetDocument();

// Operations
public:
	long m_nTimerInterval;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAtcView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL DestroyWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	double CalcDistance(double x1, double y1, double x2, double y2);
	void CheckForApproachThreshold(CDC *dc);
	void ShowInfos(CDC *dc);
	void DisplayAircrafts(CDC *dc);
	virtual ~CAtcView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CAtcView)
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in atcView.cpp
inline CAtcDoc* CAtcView::GetDocument()
   { return (CAtcDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ATCVIEW_H__4846C8A4_267F_449D_87A4_60BB725EDD2F__INCLUDED_)
